import { createElement } from 'react';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var isFunction = function isFunction(x) {
  return 'Function' == Object.prototype.toString.call(x).slice(8, -1);
};

var omit = function omit(attrs, obj) {
  if (attrs.length == 0) {
    return obj;
  }

  var result = {};
  var index = {};

  for (var _iterator = attrs, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
    var _ref;

    if (_isArray) {
      if (_i >= _iterator.length) break;
      _ref = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      _ref = _i.value;
    }

    var _name = _ref;
    index[_name] = true;
  }

  for (var name in obj) {
    if (!index[name]) {
      result[name] = obj[name];
    }
  }

  return result;
};

function dye(cssClasses, Component) {
  if (Component === void 0) {
    Component = 'div';
  }

  for (var _len = arguments.length, styleProps = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    styleProps[_key - 2] = arguments[_key];
  }

  var StyledComponent = function StyledComponent(props) {
    var newClassName = isFunction(cssClasses) ? cssClasses(props) : cssClasses;
    if (props.className) newClassName += " " + props.className;

    var newProps = _extends({}, omit(['children'].concat(styleProps), props), {
      className: newClassName
    });

    return createElement(Component, newProps, props.children);
  };

  return StyledComponent;
}

export default dye;
//# sourceMappingURL=react-dye.esm.js.map
